unit ugeoprops;

{$mode OBJFPC}{$H+}


interface

uses
  Types, Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, LDockTree, Menus, ActnList, ComCtrls, Buttons,
  uinformation, upnlpanel, CadApi, Windows, IniFiles, ucustomcomm;

type

  { TFrmMain }

  TFrmMain = class(TForm)
    act: TActionList;
    actFilesClose: TAction;
    actFilesNew: TAction;
    actFilesOpen: TAction;
    actFilesSave: TAction;
    actFilesShowProjOpt: TAction;
    actFileLoadTemplateFile: TAction;
    actFilesJustSave: TAction;
    actFilesJustSaveAs: TAction;
    actFilesOpenRecent: TAction;
    actFilesPrint: TAction;
    actFilesPrintPreview: TAction;
    actFilesPrinterSetup: TAction;
    actFilesPrinterClosePreview: TAction;
    actDrawPoint: TAction;
    actDrawLine: TAction;
    actDrawRay: TAction;
    actDrawXLine: TAction;
    actDrawMLine: TAction;
    actDrawPolyline: TAction;
    actDrawPolygon: TAction;
    actDrawRect: TAction;
    actDrawCircleCR: TAction;
    actDrawCircleCD: TAction;
    actDrawCircle2p: TAction;
    actDrawCircle3p: TAction;
    actDrawEllipse: TAction;
    actDrawHatch: TAction;
    actDrawArc: TAction;
    actDrawArc3p: TAction;
    actDrawArcSCE: TAction;
    actDrawArcSCA: TAction;
    actDrawArcSCL: TAction;
    actDrawArcSEA: TAction;
    actDrawArcSED: TAction;
    actDrawArcSER: TAction;
    actDrawArcCSE: TAction;
    actDrawArcCSA: TAction;
    actDrawArcCSL: TAction;
    actDrawArcCont: TAction;
    actDrawSpline: TAction;
    actDrawText: TAction;
    actDrawMText: TAction;
    actDrawWindowsText: TAction;
    actDrawDimLinear: TAction;
    actDrawDimAligned: TAction;
    actDrawDimOrd: TAction;
    actDrawDimRadius: TAction;
    actDrawDimDiam: TAction;
    actDrawDimAngle: TAction;
    actDrawDimArrow: TAction;
    actDrawDimCloud: TAction;
    actDrawDimCenterMark: TAction;
    actDrawDimLeader: TAction;
    actDrawDimTagCoord: TAction;
    actGeoPropsProcShapes: TAction;
    actSysUpDownTab: TAction;
    actZoomPanDown: TAction;
    actZoomPanUp: TAction;
    actZoomPanRight: TAction;
    actZoomPanLeft: TAction;
    actZoomPan2p: TAction;
    actZoomOut: TAction;
    actZoomIn: TAction;
    actZoomPan: TAction;
    actZoomRealTime: TAction;
    actZoomPrev: TAction;
    actZoomWindow: TAction;
    actZoomExt: TAction;
    actModRedo: TAction;
    actModUndo: TAction;
    actModExtend: TAction;
    actModTrim: TAction;
    actModJoin: TAction;
    actModErase: TAction;
    actModExplode: TAction;
    actModMirror: TAction;
    actModScale: TAction;
    actModRotate: TAction;
    actModMove: TAction;
    actModCopy: TAction;
    actViewZoomReset: TAction;
    actSysShowAnyPanel: TAction;
    actSysSaveIni: TAction;
    actSysLoadIni: TAction;
    actSysInitialization: TAction;
    actSysLoadTemplate: TAction;
    actSysShowDwgOptions: TAction;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    GroupBox10: TGroupBox;
    GroupBox11: TGroupBox;
    GroupBox12: TGroupBox;
    GroupBox13: TGroupBox;
    GroupBox14: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    GroupBox9: TGroupBox;
    ImageList1: TImageList;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lblFileName: TLabel;
    lblShowDrawpnl: TLabel;
    lblShowViewpnl: TLabel;
    lblShowViewGeoProps: TLabel;
    lblXRuler: TLabel;
    lblYRuler: TLabel;
    lstCommand: TListBox;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    pnlCad: TPanel;
    pnlImput: TPanel;
    pnlStatus: TPanel;
    pnlCommand: TPanel;
    pnlProperties: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton18: TSpeedButton;
    SpeedButton19: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton20: TSpeedButton;
    SpeedButton21: TSpeedButton;
    SpeedButton22: TSpeedButton;
    SpeedButton23: TSpeedButton;
    SpeedButton24: TSpeedButton;
    SpeedButton25: TSpeedButton;
    SpeedButton26: TSpeedButton;
    SpeedButton9: TSpeedButton;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    tbLines: TToolButton;
    tbText: TToolButton;
    ToolBar1: TToolBar;
    ToolBar10: TToolBar;
    ToolBar11: TToolBar;
    ToolBar12: TToolBar;
    ToolBar13: TToolBar;
    ToolBar2: TToolBar;
    ToolBar3: TToolBar;
    ToolBar4: TToolBar;
    ToolBar5: TToolBar;
    ToolBar6: TToolBar;
    ToolBar7: TToolBar;
    ToolBar8: TToolBar;
    ToolBar9: TToolBar;
    ToolButton1: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    ToolButton2: TToolButton;
    ToolButton20: TToolButton;
    ToolButton21: TToolButton;
    ToolButton22: TToolButton;
    ToolButton23: TToolButton;
    ToolButton24: TToolButton;
    ToolButton25: TToolButton;
    ToolButton26: TToolButton;
    ToolButton27: TToolButton;
    ToolButton28: TToolButton;
    ToolButton29: TToolButton;
    ToolButton3: TToolButton;
    ToolButton30: TToolButton;
    ToolButton31: TToolButton;
    ToolButton32: TToolButton;
    ToolButton33: TToolButton;
    ToolButton34: TToolButton;
    ToolButton35: TToolButton;
    ToolButton36: TToolButton;
    ToolButton37: TToolButton;
    ToolButton38: TToolButton;
    ToolButton39: TToolButton;
    ToolButton4: TToolButton;
    ToolButton40: TToolButton;
    ToolButton41: TToolButton;
    ToolButton42: TToolButton;
    ToolButton43: TToolButton;
    ToolButton44: TToolButton;
    ToolButton45: TToolButton;
    ToolButton46: TToolButton;
    ToolButton47: TToolButton;
    ToolButton48: TToolButton;
    ToolButton49: TToolButton;
    ToolButton5: TToolButton;
    ToolButton50: TToolButton;
    ToolButton51: TToolButton;
    ToolButton52: TToolButton;
    ToolButton53: TToolButton;
    ToolButton54: TToolButton;
    ToolButton55: TToolButton;
    ToolButton56: TToolButton;
    ToolButton57: TToolButton;
    ToolButton58: TToolButton;
    ToolButton59: TToolButton;
    ToolButton6: TToolButton;
    ToolButton60: TToolButton;
    ToolButton61: TToolButton;
    ToolButton62: TToolButton;
    ToolButton63: TToolButton;
    ToolButton64: TToolButton;
    ToolButton65: TToolButton;
    ToolButton66: TToolButton;
    ToolButton67: TToolButton;
    ToolButton68: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    procedure actDrawArc3pExecute(Sender: TObject);
    procedure actDrawArcContExecute(Sender: TObject);
    procedure actDrawArcCSAExecute(Sender: TObject);
    procedure actDrawArcCSEExecute(Sender: TObject);
    procedure actDrawArcCSLExecute(Sender: TObject);
    procedure actDrawArcExecute(Sender: TObject);
    procedure actDrawArcSCAExecute(Sender: TObject);
    procedure actDrawArcSCEExecute(Sender: TObject);
    procedure actDrawArcSCLExecute(Sender: TObject);
    procedure actDrawArcSEAExecute(Sender: TObject);
    procedure actDrawArcSEDExecute(Sender: TObject);
    procedure actDrawArcSERExecute(Sender: TObject);
    procedure actDrawCircle2pExecute(Sender: TObject);
    procedure actDrawCircle3pExecute(Sender: TObject);
    procedure actDrawCircleCDExecute(Sender: TObject);
    procedure actDrawCircleCRExecute(Sender: TObject);
    procedure actDrawDimAlignedExecute(Sender: TObject);
    procedure actDrawDimAngleExecute(Sender: TObject);
    procedure actDrawDimArrowExecute(Sender: TObject);
    procedure actDrawDimCenterMarkExecute(Sender: TObject);
    procedure actDrawDimCloudExecute(Sender: TObject);
    procedure actDrawDimDiamExecute(Sender: TObject);
    procedure actDrawDimLeaderExecute(Sender: TObject);
    procedure actDrawDimLinearExecute(Sender: TObject);
    procedure actDrawDimOrdExecute(Sender: TObject);
    procedure actDrawDimRadiusExecute(Sender: TObject);
    procedure actDrawDimTagCoordExecute(Sender: TObject);
    procedure actDrawEllipseExecute(Sender: TObject);
    procedure actDrawHatchExecute(Sender: TObject);
    procedure actDrawLineExecute(Sender: TObject);
    procedure actDrawMLineExecute(Sender: TObject);
    procedure actDrawMTextExecute(Sender: TObject);
    procedure actDrawPointExecute(Sender: TObject);
    procedure actDrawPolygonExecute(Sender: TObject);
    procedure actDrawPolylineExecute(Sender: TObject);
    procedure actDrawRayExecute(Sender: TObject);
    procedure actDrawRectExecute(Sender: TObject);
    procedure actDrawSplineExecute(Sender: TObject);
    procedure actDrawTextExecute(Sender: TObject);
    procedure actDrawWindowsTextExecute(Sender: TObject);
    procedure actDrawXLineExecute(Sender: TObject);
    procedure actFilesCloseExecute(Sender: TObject);
    procedure actFilesJustSaveAsExecute(Sender: TObject);
    procedure actFilesJustSaveExecute(Sender: TObject);
    procedure actFilesNewExecute(Sender: TObject);
    procedure actFilesOpenExecute(Sender: TObject);
    procedure actFilesPrinterClosePreviewExecute(Sender: TObject);
    procedure actFilesPrinterSetupExecute(Sender: TObject);
    procedure actFilesPrintExecute(Sender: TObject);
    procedure actFilesPrintPreviewExecute(Sender: TObject);
    procedure actFilesSaveExecute(Sender: TObject);
    procedure actGeoPropsProcShapesExecute(Sender: TObject);
    procedure actModCopyExecute(Sender: TObject);
    procedure actModEraseExecute(Sender: TObject);
    procedure actModExplodeExecute(Sender: TObject);
    procedure actModExtendExecute(Sender: TObject);
    procedure actModJoinExecute(Sender: TObject);
    procedure actModMirrorExecute(Sender: TObject);
    procedure actModMoveExecute(Sender: TObject);
    procedure actModRedoExecute(Sender: TObject);
    procedure actModRotateExecute(Sender: TObject);
    procedure actModScaleExecute(Sender: TObject);
    procedure actModTrimExecute(Sender: TObject);
    procedure actModUndoExecute(Sender: TObject);
    procedure actSysInitializationExecute(Sender: TObject);
    procedure actSysLoadIniExecute(Sender: TObject);
    procedure actFileLoadTemplateFileExecute(Sender: TObject);
    procedure actSysSaveIniExecute(Sender: TObject);
    procedure actSysSelectPageExecute(Sender: TObject);
    procedure actSysShowAnyPanelExecute(Sender: TObject);
    procedure actSysUpDownTabExecute(Sender: TObject);
    procedure actViewZoomResetExecute(Sender: TObject);
    procedure actZoomExtExecute(Sender: TObject);
    procedure actZoomInExecute(Sender: TObject);
    procedure actZoomOutExecute(Sender: TObject);
    procedure actZoomPan2pExecute(Sender: TObject);
    procedure actZoomPanDownExecute(Sender: TObject);
    procedure actZoomPanExecute(Sender: TObject);
    procedure actZoomPanLeftExecute(Sender: TObject);
    procedure actZoomPanRightExecute(Sender: TObject);
    procedure actZoomPanUpExecute(Sender: TObject);
    procedure actZoomPrevExecute(Sender: TObject);
    procedure actZoomRealTimeExecute(Sender: TObject);
    procedure actZoomWindowExecute(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: char);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure lstCommandDrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
    procedure pnlCadResize(Sender: TObject);
    procedure pnlCommandResize(Sender: TObject);
    procedure pnlPropertiesResize(Sender: TObject);
    procedure SelectPage(Sender: TObject);
  private
    procedure UpdateFileNameTag;
    procedure UpdateRullers (XWin, YWin: Integer; XDwg, YDwg: Double);
    procedure GetPanel(oPanel, oDest: TControl);
    procedure GetBlock(sBlockName: TStrBuff);
  public

  end;

const
  Tag_Draw = 1; Tag_View = 2; Tag_GeoProp = 3;
  DefaultDrawingFileName = 'Default.vec';
  ProfileFileName = 'Default';
  IniProfileName = 'appsettings.ini';
  NewFileName = 'NewFile.vec';
var
  FrmMain: TFrmMain;
  hEnt, pEnt, hDWG, hWND, hCW, hLayer, HPropsDlg, idObj, hBlock, IdBlock: THandle;
  EntType: DWORD;
  TmpFilePath, AppPath: TFileName;
  ExtendedSettings, CustomApps : TIniFile;
  KeyFlag: boolean;

procedure EntChangeProc(hDwg, hEnt: THandle); stdcall;
procedure EntCreateProc(hDwg, hEnt: THandle); stdcall;
procedure MouseMoveProc(hDwg, Button, Key, Xwin, Ywin: Integer; Xdwg, Ydwg, Zdwg: Double); stdcall;
procedure KeyDownProc(hDwg, VirtKey, Flags: integer; bCtrl, bShift: boolean); stdcall;
procedure PromptProc(hDwg: Integer; Cs: PChar); stdcall;     // prompt text
procedure CmdFinisheProc(hDwg: Thandle; Command: Integer);stdcall;   // command identifier
procedure MouseDblClkProc(hDwg: Thandle; Button, Key, Xwin, Ywin: Integer; Xdwg, Ydwg, Zdwg: Double); stdcall;



implementation


{$R 'Custom.res'}
{$R *.frm}

{ TFrmMain }

{%Region CAD_events}
procedure MouseDblClkProc(hDwg: Thandle; Button, Key, Xwin, Ywin: Integer; Xdwg, Ydwg, Zdwg: Double); stdcall;
var
  nEnts: UINT;
begin
  nEnts:= CadSelCount(hDwg);
  if Boolean(nEnts) then begin
    // get selected entities and show their data f
    pEnt:= CadSelGetFirstPtr(hDwg);
    if pEnt = 0 then Exit;
    hEnt:= CadGetEntityByPtr(pEnt);

    frmShowData.ShowData(hEnt);
    CadSelClear(hDwg);
    CadUpdate(hdwg);
    CadWndRedraw(hWND);
  end;
end;

procedure EntChangeProc(hDwg, hEnt:THandle); stdcall;
begin
 CadPutDirty(hDwg, 1);
 FrmMain.UpdateFileNameTag;
end;

procedure EntCreateProc(hDwg, hEnt: THandle); stdcall;
begin
  FrmMain.UpdateFileNameTag;
end;

procedure MouseMoveProc(hDwg, Button, Key, Xwin, Ywin: Integer; Xdwg, Ydwg, Zdwg: Double); stdcall;
begin
  FrmMain.UpdateRullers(XWin, YWin, XDwg, YDwg);
end;

procedure KeyDownProc(hDwg, VirtKey, Flags: integer; bCtrl, bShift: boolean); stdcall;
begin
// FrmMain.Label2.Caption:= IntToStr(VirtKey);
 //PostKeyEx(FrmMain.Edit1.Handle, VirtKey, [], False);
 // PostMessage(FrmMain.Edit1.Handle, WM_CHAR, VirtKey, 0);
// FrmMain.Edit1.SetFocus;
 if KeyFlag then begin
   KeyFlag:= False;
   PostMessage(FrmMain.Edit1.Handle, WM_KEYDOWN, VirtKey, 0);
   Application.ProcessMessages;
   KeyFlag:=True;
 end;
 //PostMessage(FrmMain.Edit1.Handle, WM_KEYUP, VirtKey, 0);
end;

procedure PromptProc(hDwg: Integer; Cs: PChar); stdcall;     // prompt text
var
  s: String;
begin
 s:= Cs;
 s:= trim(s);
 if s = '' then exit;
 FrmMain.lstCommand.Items.Append(s);
 FrmMain.lstCommand.ItemIndex:= frmMain.lstCommand.Items.Count-1;;
end;

procedure CmdFinisheProc(hDwg: Thandle; Command: Integer);stdcall;
begin
 PromptProc(hDwg, 'Ready:');
end;

{%ENDRegion CAD_events}


{%REGION main methods}
procedure TFrmMain.UpdateFileNameTag;
var
  s: TStrBuff;

begin
 CadGetShortFileName(hDwg, @s);
 lblFileName.Caption:= s;
 if Boolean(CadGetDirty(hDwg)) then begin
     lblFileName.Font.Color:= clRed;
 end else begin
     lblFileName.Font.Color:= clBlack;
 end;
end;

procedure TFrmMain.UpdateRullers (XWin, YWin: Integer; XDwg, YDwg: Double);
var
  s: string;
begin
  s:= '|  ' + FloatToStrF(Xdwg,ffFixed, 8, 3) + '';
  FrmMain.lblXRuler.Caption:= s;
  FrmMain.lblXRuler.Left:=Xwin-1;
  s:= '|  ' + FloatToStrF(Ydwg, ffFixed,8, 3) + '';
  FrmMain.lblYRuler.Caption:= s;
  FrmMain.lblyRuler.Top :=Ywin - FrmMain.lblYRuler.Height +3;
end;

procedure TFrmMain.GetPanel(oPanel, oDest: TControl);
var
  coor: TPoint;
begin
 with oPanel do begin
   Parent:= FrmMain;
   coor:= Types.Point(oDest.Width, oDest.Height);
   coor:= oDest.ClientToScreen(coor);

   //GetCursorPos(coor);
   coor:=FrmMain.ScreenToClient(coor);
   Left:= coor.X;
   Top:= coor.Y ;
   Visible:=True;
  end;
end;

procedure TFrmMain.GetBlock(sBlockName: TStrBuff);
var
 BlockData: TCMDPRM_INSERT_BLOCK;
 s: TStrBuff;
begin
  hEnt:= CadAddBlockFromFile(hDwg, StrToBuffPtr(AppPath + 'SymbolDB.vec', s), @sBlockName);
  if hEnt = 0 then exit;
  idObj:= CadBlockGetID(hEnt);
  with BlockData do begin
    bShowDialog:= 0;   // hide the "Insert Block" dialog
    idBlock:= idObj;     // identifier of block
    bCoord:= 0;        // specify coordinates "on-screen"
    InsPntX:= 0.0;     // insertion point coordinates
    InsPntY:= 0.0;
    InsPntZ:= 0.0;
    bScale:= 1;        // use the specified scale
    bUniScale:= 0;
    ScaleX:= 2.0;      // block scale
    ScaleY:= 2.0;
    ScaleZ:= 2.0;
    bAngle:= 0;        // specify angle "on-screen"
    Angle:= 0.0;       // rotation angle
    bExplode:= 1;
    RowDist:= 1.0;
    ColDist:= 1.0;
    NumRows:= 1;
    NumCols:= 1;
  end;
  CadSetCmdParam( hDwg, CAD_CMD_INSERT_BLOCK, @BlockData);
  CadExecute(hDwg, hWND, CAD_CMD_INSERT_BLOCK );
end;

{%ENDREGION main methods}

{%REGION MainFormEvents}
procedure TFrmMain.pnlCadResize(Sender: TObject);
begin
  CadWndResize(hWND, 0, 0, pnlCad.Width, pnlCad.Height);
end;

procedure TFrmMain.pnlCommandResize(Sender: TObject);
begin
  //CadCWResize(0,0,500, pnlCommand.Height);
 //CadCWDelete;
 //hCW:= CadCWCreate(pnlCommand.Handle, 0, 0, 500, pnlCommand.Height);
end;

procedure TFrmMain.pnlPropertiesResize(Sender: TObject);
begin
  if pnlProperties.Width > 100 then //dont try resize under 50 pix!! won't work!
     SetWindowPos(HPropsDlg,0,0,0,pnlProperties.Width,pnlProperties.Height,0);
end;

procedure TFrmMain.SelectPage(Sender: TObject);
begin
  PageControl1.ActivePageIndex:= Tcontrol(Sender).tag;
  actSysUpDownTab.Checked:=true;
  actSysUpDownTab.Execute;
end;

procedure TFrmMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  ChDir(AppPath);
   if not Boolean(CadProfileSave('')) then  //Save Profile
     ShowMessage('Canot save profile');
   if ExtendedSettings <> nil then begin
       actSysSaveIni.Execute;
       ExtendedSettings.Free; // Save extended settings on ini file
   end;

end;

procedure TFrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:= False;
  actFilesSave.Execute;
  CanClose:= Boolean(actFilesSave.Tag);
end;

procedure TFrmMain.FormDestroy(Sender: TObject);
begin
  CadCWDelete;
  CadDelete(hDwg);
end;

procedure TFrmMain.lstCommandDrawItem(Control: TWinControl; Index: Integer;
  ARect: TRect; State: TOwnerDrawState);
begin
  with lstCommand.Canvas do begin
   // if odSelected in State then
    Brush.Color := lstCommand.Color;
    FillRect(ARect);
   //    Brush.Color := clYellow;
    if odSelected in State then Font.Color:=clBlue
                           else Font.Color:=clGray;
    TextOut(ARect.left, ARect.Top, lstCommand.Items[Index]);
    //if odFocused in State then
    //    DrawFocusRect(ARect);
 end
end;

{%ENDREGION MainFormEventsEvents}

{%REGION Actions}
procedure TFrmMain.actSysInitializationExecute(Sender: TObject);
// System initialization
begin
  PageControl1.ShowTabs:=false;
  CadOnEventEntChange(@EntChangeProc);
  CadOnEventEntCreate(@EntCreateProc);
  CadOnEventMouseMove(@MouseMoveProc);
  CadOnEventKeyDown(@KeyDownProc);
  CadOnEventPrompt(@PromptProc);
  CadOnEventCmdFinish(@CmdFinisheProc);
  CadOnEventMouseDblClk(@MouseDblClkProc);


  CadAccelSetDefault; //Set default access keys on
  hDWG:= CadCreate; //Create drawing database object
  hWND:= CadWndCreate(hDWG, pnlCad.Handle,    //Create Drawing window
         CAD_WS_DEFAULT - CAD_WS_HSCROLL -CAD_WS_VSCROLL , 0, 0, pnlCad.Width, pnlCad.Height);

  //hCW:= CadCWCreate(pnlCommand.Handle, 0, 0, 500, pnlCommand.Height);

  //Dock Properties window on ptoperties panel
  CadExecute(hDWG,hWND,CAD_CMD_ENTPROP);  //call properties window
  HPropsDlg:= FindWindow(nil, 'Properties - Drawing.vec'); //Get properties window handle
  ShowPropWndEmbedded(HPropsDlg,pnlProperties); //Dock properties window on pnlproperties

  actFileLoadTemplateFile.Execute; // Load default empty file
  CadWndSetFocus (hWND);
  UpdateRullers(0,0,0,0);

  //Custom commands
  CreateShapePropCommand;

  if not Boolean(CadProfileLoad(ProfileFileName)) then
         ShowMessage('Canot load profile options');
  actSysLoadIni.Execute;

  CadSetParam(CAD_GL_SHOWCOMPASS, 2);
  //CadSetAngleUnit(CAD_ANGLE_DEGREE);
  KeyFlag:=True;
end;

procedure TFrmMain.actFilesSaveExecute(Sender: TObject);
var
  bChanged, bNoFileName: Boolean;
  s: TStrBuff;
  r: integer;
begin
 actFilesSave.Tag:= 1;
 bChanged:= Boolean(CadGetDirty(hDwg)); //Get drawing changed flag
 CadGetFileName(hDwg,@s);
 bNofileName:= (ExtractFileName(s) = NewFileName);
 if bChanged then begin
    r:= Application.MessageBox('Save changes before close?', 'Changed file!', mb_YesNoCancel);  // case changed ask for saving
    case r of
    IDYES: begin
             if bNoFileName then actFilesSave.Tag:= CadFileSaveAs(hDwg, hWND,'') //if unamed then 'save as' else 'save'
                            else actFilesSave.Tag:= CadFileSave(hDwg,hWND);
             //exit; // if saveas.tag = 0 then exit?
            end;
    IDNO:  begin
             actFilesSave.Tag:= 1;   // do not/ignore save
           end;
    IDCANCEL: actFilesSave.Tag:=0; // save canceled action canceled
    end;
 end;
end;

procedure TFrmMain.actGeoPropsProcShapesExecute(Sender: TObject);
begin
  //execute geometric properties of shapes command
 CadExecute(hDWG, hWND, CMD_DOSHAPEPROP);
end;

procedure TFrmMain.actModCopyExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_COPY);
end;

procedure TFrmMain.actModEraseExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_ERASE);
end;

procedure TFrmMain.actModExplodeExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_EXPLODE);
end;

procedure TFrmMain.actModExtendExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_EXTEND);
end;

procedure TFrmMain.actModJoinExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_JOIN);
end;

procedure TFrmMain.actModMirrorExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_MIRROR);
end;

procedure TFrmMain.actModMoveExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_MOVE);
end;

procedure TFrmMain.actModRedoExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_REDO);
end;

procedure TFrmMain.actModRotateExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_ROTATE);
end;

procedure TFrmMain.actModScaleExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_SCALE);
end;

procedure TFrmMain.actModTrimExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_TRIM);
end;

procedure TFrmMain.actModUndoExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_UNDO);
end;

procedure TFrmMain.actFilesOpenExecute(Sender: TObject);
begin
  actFilesSave.Execute;
  if actFilesSave.Tag > 0 then
     CadFileOpen(hDwg,hWND, ''); {Open file dialog};
  UpdateFileNameTag;
end;

procedure TFrmMain.actFilesPrinterClosePreviewExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_PRINTPREVIEW_END);
end;

procedure TFrmMain.actFilesPrinterSetupExecute(Sender: TObject);
begin
  CadPrintSetup(hWND);
end;

procedure TFrmMain.actFilesPrintExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_PRINT);
end;

procedure TFrmMain.actFilesPrintPreviewExecute(Sender: TObject);
begin
  CadExecute(hDWG,hWND, CAD_CMD_PRINTPREVIEW);
end;

procedure TFrmMain.actFilesNewExecute(Sender: TObject);
begin
  actFilesSave.Execute;
  if actFilesSave.Tag > 0 then
     actFileLoadTemplateFile.Execute; //Load new empty file from template
  UpdateFileNameTag;
end;

procedure TFrmMain.actFilesJustSaveExecute(Sender: TObject);
var
   bNoFileName: Boolean;
   s: TStrBuff;
begin
 CadGetFileName(hDwg,@s);
 bNofileName:= (ExtractFileName(s) = NewFileName);
 if bNoFileName then CadFileSaveAs(hDwg, hWND,'')
                else CadFileSave(hDwg,hWND);
 UpdateFileNameTag;
end;

procedure TFrmMain.actFilesJustSaveAsExecute(Sender: TObject);
begin
 CadFileSaveAs(hDwg, hWND, '');
 UpdateFileNameTag;
end;

procedure TFrmMain.actDrawPointExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_POINT);
end;

procedure TFrmMain.actDrawPolygonExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_DRAW_POLYGON);
end;

procedure TFrmMain.actDrawPolylineExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_POLYLINE);
  tbLines.Action:= actDrawPolyline;
  frmPanelFFF.tbLines2.Action:= actDrawPolyline;
end;

procedure TFrmMain.actDrawRayExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_RAY);
  tbLines.Action:= actDrawRay;
  frmPanelFFF.tbLines2.Action:= actDrawRay;
end;

procedure TFrmMain.actDrawRectExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_RECT);
end;

procedure TFrmMain.actDrawSplineExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_DRAW_SPLINE);
 tbLines.Action:= actDrawSpline;
 frmPanelFFF.tbLines2.Action:= actDrawSpline;
end;

procedure TFrmMain.actDrawTextExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_TEXT);
  tbText.Action:= actDrawText;
end;

procedure TFrmMain.actDrawWindowsTextExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_WTEXT);
  tbText.Action:= actDrawWindowsText;
end;

procedure TFrmMain.actDrawXLineExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_XLINE);
  tbLines.Action:= actDrawXLine;
  frmPanelFFF.tbLines2.Action:= actDrawXLine;
end;

procedure TFrmMain.actFilesCloseExecute(Sender: TObject);
begin

end;

procedure TFrmMain.actDrawLineExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_LINE);
  tbLines.Action:= actDrawLine;
  frmPanelFFF.tbLines2.Action:= actDrawLine;
end;

procedure TFrmMain.actDrawCircleCRExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_CIRCLE);
end;

procedure TFrmMain.actDrawDimAlignedExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_DIM_ALIGN);
end;

procedure TFrmMain.actDrawDimAngleExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_DIM_ANG);
end;

procedure TFrmMain.actDrawDimArrowExecute(Sender: TObject);
begin
  GetBlock('anotationarrow');
end;

procedure TFrmMain.actDrawDimCenterMarkExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_DRAW_CENMARK);
end;

procedure TFrmMain.actDrawDimCloudExecute(Sender: TObject);
begin
  GetBlock('cloudanotation');
end;

procedure TFrmMain.actDrawDimDiamExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_DIM_DIAM);
end;

procedure TFrmMain.actDrawDimLeaderExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_LEADER);
end;

procedure TFrmMain.actDrawDimLinearExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_DRAW_DIM_LIN);
end;

procedure TFrmMain.actDrawDimOrdExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_DRAW_DIM_ORD);
end;

procedure TFrmMain.actDrawDimRadiusExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_DRAW_DIM_RAD);
end;

procedure TFrmMain.actDrawDimTagCoordExecute(Sender: TObject);
 var
   nEnts: UINT;
   hPtr: THANDLE;
   EntType: DWORD;
   errors: UINT;
begin
  PromptProc(hDWG, 'Tag vertex:');
  nEnts:= CadSelCount(hDwg);
  if nEnts = 0 then PromptProc(hDWG, 'Tag vertex error: No entities selected!');
     //MessageBox(hWND, 'No entities with vertexes selected!', 'Coordinates tagging error', 1);
 //begin tag procedure
  errors:= 0;
  hPtr:= CadSelGetFirstPtr(hDwg);
  while Boolean(hPtr) do begin
     hEnt:= CadGetEntityByPtr(hPtr);
     EntType:= CadEntityGetType(hEnt);
     hPtr:= CadSelGetNextPtr(hDwg, hPtr);
     case EntType of
       CAD_ENT_POINT, CAD_ENT_LINE,
       CAD_ENT_POLYLINE,CAD_ENT_RECT: ;
     else
       Inc(errors,1);
     end; // case enttype
  end;
 if Boolean(errors) then
    PromptProc(hDWG, 'Tag vertex errors detected: Some selected entities may not have valid vertexes to tag!');
       //MessageBox(hWND, 'Some selected entities may not have valid vertexes to tag!', 'Coordinates tagging errors detected', 1);
 CadSelClear(hDwg);
 CadUpdate(hDWG);
end;

procedure TFrmMain.actDrawEllipseExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_ELLIPSE);
end;

procedure TFrmMain.actDrawHatchExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_HATCH);
end;

procedure TFrmMain.actDrawCircleCDExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_CIRC_CD);
end;

procedure TFrmMain.actDrawCircle2pExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_CIRC_2P);
end;

procedure TFrmMain.actDrawArcExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC);
end;

procedure TFrmMain.actDrawArcSCAExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC_SCA);
end;

procedure TFrmMain.actDrawArcSCEExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC_SCE);
end;

procedure TFrmMain.actDrawArcSCLExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC_SCL);
end;

procedure TFrmMain.actDrawArcSEAExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC_SEA);
end;

procedure TFrmMain.actDrawArcSEDExecute(Sender: TObject);
begin
   CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC_SED);
end;

procedure TFrmMain.actDrawArcSERExecute(Sender: TObject);
begin
   CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC_SER);
end;

procedure TFrmMain.actDrawArc3pExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC3P);
end;

procedure TFrmMain.actDrawArcContExecute(Sender: TObject);
begin
   CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC_CONT);
end;

procedure TFrmMain.actDrawArcCSAExecute(Sender: TObject);
begin
   CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC_CSA);
end;

procedure TFrmMain.actDrawArcCSEExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC_CSE);
end;

procedure TFrmMain.actDrawArcCSLExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_DRAW_ARC_CSL);
end;

procedure TFrmMain.actDrawCircle3pExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_CIRC_3P);
end;

procedure TFrmMain.actDrawMLineExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_MLINE);
  tbLines.Action:= actDrawMLine;
  frmPanelFFF.tbLines2.Action:= actDrawMLine;
end;

procedure TFrmMain.actDrawMTextExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_DRAW_MTEXT);
  tbText.Action:= actDrawMText;
end;

procedure TFrmMain.actFileLoadTemplateFileExecute(Sender: TObject);
begin
  //Open default file template
  AppPath:= ExtractFilePath(Application.ExeName); //Get app path
  ChDir(AppPath); //Change to app location
  if not Boolean(CadFileOpen(hDWG, hWND, DefaultDrawingFileName)) then               //StrToBuffPtr(apppath, StrBuff)
         ShowMessage('Failed to load template');
  CadPutFileName(hDwg, NewFileName);
  UpdateFileNameTag;
end;

procedure TFrmMain.actSysLoadIniExecute(Sender: TObject); //Create extended ini profile
var
  bcolor, stepcolor, btype, steptype: DWORD;
begin
  ExtendedSettings:= TIniFile.Create(IniProfileName);
  with ExtendedSettings do
  begin
    bcolor:= ReadInteger('GRID', 'boldcolor', 0); //read grid boldstep color
    stepcolor:= ReadInteger('GRID', 'stepcolor', 0); //read grid step color
    btype:= ReadInteger('GRID', 'boldtype', 0); //read grid boldstep type
    steptype:= ReadInteger('GRID', 'steptype', 0); //read grid step type

    CadGridPutColor(hDwg, 1, bcolor); //apply bold step color
    CadGridPutColor(hDwg, 0, stepcolor); //apply step color
    CadGridPutType(hDwg, 1, btype); //apply bold step type
    CadGridPutType(hDwg, 0, steptype); //apply step type

    custPrecision:= ReadInteger('GEOPROPS', 'precigion', 4);
    custUnit:= ReadString('GEOPROPS', 'unit', 'U');
  end;
end;

procedure TFrmMain.actSysSaveIniExecute(Sender: TObject);
var
  bcolor, stepcolor, btype, steptype:DWORD;
begin
  with ExtendedSettings do
  begin
    bcolor:=  CadGridGetColor(hDWG,1);
    stepcolor:= CadGridGetColor(hDWG,0);
    btype:= CadGridGetType(hDwg,1);
    steptype:= CadGridGetType(hDwg,0);

    WriteInteger('GRID', 'boldcolor', bcolor);
    WriteInteger('GRID', 'stepcolor', stepcolor);
    WriteInteger('GRID', 'boldtype', btype);
    WriteInteger('GRID', 'steptype', steptype);

    WriteInteger('GEOPROPS', 'precigion', custPrecision);
    WriteString('GEOPROPS', 'unit', custUnit);
  end;
end;

procedure TFrmMain.actSysSelectPageExecute(Sender: TObject);
begin
  PageControl1.ActivePageIndex:= TControl(Sender).Tag
end;

procedure TFrmMain.actSysShowAnyPanelExecute(Sender: TObject);

begin
  //make a show panel at  procedure!!!!!!
 case TControl(Sender).Tag of
  Tag_Draw: GetPanel(frmPanelFFF.pnlDraw, lblShowDrawpnl);
  Tag_View: GetPanel(frmPanelFFF.pnlView, lblShowViewpnl);
  Tag_GeoProp: GetPanel(frmPanelFFF.pnlGeoprops, lblShowViewGeoProps);
 end;
end;

procedure TFrmMain.actSysUpDownTabExecute(Sender: TObject);
var
  fb: boolean;
begin
  fb:= Not(TAction(Sender).Checked);
  PageControl1.Visible:= fb;
  if fb then actSysUpDownTab.ImageIndex:= 92
        else actSysUpDownTab.ImageIndex:= 93;
end;

procedure TFrmMain.actViewZoomResetExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_ZOOM_EXT);
end;

procedure TFrmMain.actZoomExtExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_ZOOM_EXT);
end;

procedure TFrmMain.actZoomInExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_ZOOM_IN);
end;

procedure TFrmMain.actZoomOutExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_ZOOM_OUT);
end;

procedure TFrmMain.actZoomPan2pExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_PAN_POINT);
end;

procedure TFrmMain.actZoomPanDownExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_PAN_DOWN);
end;

procedure TFrmMain.actZoomPanExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_PAN_RTIME);
end;

procedure TFrmMain.actZoomPanLeftExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_PAN_LEFT);
end;

procedure TFrmMain.actZoomPanRightExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_PAN_RIGHT);
end;

procedure TFrmMain.actZoomPanUpExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_PAN_UP);
end;

procedure TFrmMain.actZoomPrevExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_ZOOM_PREV);
end;

procedure TFrmMain.actZoomRealTimeExecute(Sender: TObject);
begin
  CadExecute(hDWG, hWND, CAD_CMD_ZOOM_RTIME);
end;

procedure TFrmMain.actZoomWindowExecute(Sender: TObject);
begin
 CadExecute(hDWG, hWND, CAD_CMD_ZOOM_WIN);
end;

procedure TFrmMain.Edit1KeyPress(Sender: TObject; var Key: char);
var
 // wKey: Word;
  s: TStrBuff;
begin
  if Key = #13 then begin
     s:= Edit1.Text;
     Edit1.Text:= '';
     CadCWPutText(hDwg, @s);
  end;

  {
    wKey:= VkKeyScanA(Key);
    if KeyFlag or (wKey in[8, 13]) then
    begin
      KeyFlag:= false;
      if wKey = 13 then begin
          //CadCWPutText(hDwg, LPCSTR(Edit1.Text));
          Edit1.Text:='';
      end;
      if wKey = 8 then  begin
         Edit1.SelLength:= 0;
         Edit1.SelStart:=Length(Edit1.Text)+1;
      end;
      SendMessage(hWND, WM_KEYDOWN , wKey, 0);
      Application.ProcessMessages;
      KeyFlag:=true;
    end;
   }
end;

{%ENDREGION Actions}
end.

